-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local spikestripInstance = nil
local spikestripInstanceID = nil

local function place()
	local playerVehicle = be:getPlayerVehicle(0)
    local playerVehicleID = be:getPlayerVehicleID(0)
	local dir = 0
	local rot = 0
	local position = 0
	
    for k, v in pairs(map.objects) do
      if k == playerVehicleID then
        dir = v.dirVec:normalized()
        rot = quatFromDir(dir)
      end
    end
	position = vec3(playerVehicle:getPosition()) - dir*5
	
	if spikestripInstanceID ~= nil then
		rot = rot * quat(0,0,1,0) -- rotate 180 degrees
		spikestripInstance:setPositionRotation(position.x, position.y, position.z, rot.x, rot.y, rot.z, rot.w)
	else
		M.removeSpikes()
		spawn.spawnVehicle("spikestrip", "spikestrip", position, rot)
		spikestripInstance = be:getPlayerVehicle(0)
		spikestripInstanceID = be:getPlayerVehicleID(0)
		be:enterVehicle(0, playerVehicle)
	end
end

local function removeSpikes()
	if spikestripInstanceID ~= nil then
		spikestripInstance:delete()
		spikestripInstance = nil
		spikestripInstanceID = nil
	end
end

-- public interface
M.place = place
M.removeSpikes = removeSpikes

return M
